// TYPE: C
// PRJ: YAO
// PGM: YAO
// VER: 1.2.1
// USES: Visual C++ 6.0
// CREATE: 20040126 (iwai)
// UPDATE: 20041216 (yamamoto, sugawara)
// UPDATE: 20050831 (shiina, yatou)
//////////////////////////////////////////////////
// 20041216 version 1.1.0 STLp~BC̃bp[p~BSʓICŏB
// 20050624 version 1.2.1 WindowsˑWCu֐pďB
//                        ݂̃^f[^(ʏ́uJgv)YAO_FILEɕێȂ
//                        삷悤ɎdlύXBANZX[hwł悤ɂȂB

#include "YAO.h"

//**************************************
// vg^Cv錾
//**************************************
// t@C֌W API bsO
static bool MyIsFileExists( const char * inFilePath );
static YAOStatus MySetFilePointer( YAO_FILE * ioFile, long inPosition );
static YAOStatus MySetFilePointerToEnd( YAO_FILE * ioFile );
static long MyGetCurrentFilePointer( YAO_FILE * ioFile );
static YAOStatus MyReadData( YAO_FILE * ioFile, void * outBuff, long inBufLen );
static YAOStatus MyWriteData( YAO_FILE * ioFile, const void * inBuff, long inBufLen );
static bool MyIsValidYAO_FILE( YAO_FILE * ioFile );

// YAO_METADATA ֘Å֐
static void InitMetaData( YAO_METADATA * ioMetaDataPtr );
static bool IsTagObj( YAO_METADATA inMetaData );
static YAOStatus ReadMetaData( YAO_FILE * ioFile, long inPosition, YAO_METADATA * outMetaDataPtr );
static YAOStatus WriteMetaData( YAO_FILE * ioFile, YAO_METADATA * inMetaDataPtr );

static YAOStatus FindFirstTagObj( YAO_FILE * ioFile, YAO_METADATA * outMetaDataPtr ); 
static YAOStatus FindNextTagObj( YAO_FILE * ioFile, YAO_METADATA * ioMetaDataPtr ); 
static YAOStatus FindPreviousTagObj( YAO_FILE * ioFile, YAO_METADATA * ioMetaDataPtr ); 
static YAOStatus FindLastTagObj( YAO_FILE * ioFile, YAO_METADATA * outMetaDataPtr );
static YAOStatus FindNextMember( YAO_FILE * ioFile, YAO_METADATA * ioMetaDataPtr );
static YAOStatus FindPreviousMember( YAO_FILE * ioFile, YAO_METADATA * ioMetaDataPtr );
static YAOStatus FindFirstMember( YAO_FILE * ioFile, YAOTag inTag, YAO_METADATA * outMetaDataPtr );
static YAOStatus FindLastMember( YAO_FILE * ioFile, YAOTag inTag, YAO_METADATA * outMetaDataPtr );

static YAOStatus AddTagObj( YAO_FILE * ioFile, YAOTag inTag, long inDataLen, void * inDataBuff );
static YAOStatus AddMemberObj( YAO_FILE * ioFile, YAOTag inTag, long inDataLen, void * inDataBuff );

static YAOStatus RemoveTagObj( YAO_FILE * ioFile );
static YAOStatus RemoveMemberObj( YAO_FILE * ioFile );

static YAOStatus InsertMemberObj( YAO_FILE * ioFile, long inDataLen, void * inDataBuff );
static YAOStatus InsertTagObj( YAO_FILE * ioFile, long inDataLen, void * inDataBuff );

static YAOStatus UpdateNextTag( YAO_FILE * ioFile, long inPreviousTagPos );
static YAOStatus UpdatePreviousTag( YAO_FILE * ioFile, long inNextTagPos );
static YAOStatus UpdateNextMember( YAO_FILE * ioFile, long inPreviousTagPos, long inNextTagPos );

//**************************************
// ֐
//**************************************
//------------------------------------------------
// ֐ : YAO_Create
// @\ : YAO t@CV쐬ĊJ
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//------------------------------------------------
// 20050912 mod (shiina, yatou) fopengp悤ύX
//                              YAO_FILEԂlɕύX
//                              ԂlYAOStatusɕύX
YAOStatus YAO_Create( const char * inFilePath, YAO_FILE * outFile )
{
	YAOStatus 		rc; // return code
	YAO_FILE_HEADER	fileHeader;
	YAO_METADATA	entryPointMetaData;

	// t@Cw肳Ă邩H
	if( inFilePath == NULL )
	{
		return kYAO_Failure;
	}

	// YAO_FILEw肳Ă邩H
	if( outFile == NULL )
	{
		return kYAO_Failure;
	}

	// YAO_FILE
	outFile->accessMode = kYAO_ReadWrite;
	outFile->filePointer = NULL;
	outFile->currentExist = false; // ͂߂̓JgȂ

	// t@Cɑ݂ꍇ͎s
	if ( MyIsFileExists( inFilePath ) == true )
	{
		return kYAO_Failure;
	}

	// t@CǂݏpAoCi[hŊJ
	outFile->filePointer = fopen( inFilePath, "w+b" );
	if ( outFile->filePointer == NULL )
	{
		return kYAO_Failure;
	}

	// t@Cwb_쐬
	memset( &fileHeader, 0, sizeof(YAO_FILE_HEADER) );
	fileHeader.signature[0] = 'Y';
	fileHeader.signature[1] = 'A';
	fileHeader.signature[2] = 'O';
	fileHeader.version = kYAOVersion;
	
	// t@Cwb_
	rc = MyWriteData( outFile, &fileHeader, sizeof(YAO_FILE_HEADER) );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// Gg[|Cgp̃^f[^𐶐
	InitMetaData( &entryPointMetaData );
	entryPointMetaData.dataTag = kEntryPointTag;
	entryPointMetaData.filePointer = MyGetCurrentFilePointer( outFile );

	// Gg[|Cgt@Cɏ
	rc = MyWriteData( outFile, &entryPointMetaData, sizeof(YAO_METADATA) );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	return kYAO_Success;
}

//------------------------------------------------
// ֐ : YAO_Open
// @\ : YAO t@CJ
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//------------------------------------------------
// 20050912 mod (shiina, yatou) fopengp悤ύX
//                              YAO_FILEԂlɕύX
//                              ANZX[hwł悤ɕύX
//                              ԂlYAOStatusɕύX
YAOStatus YAO_Open( const char * inFilePath, long inAccessMode, YAO_FILE * outFile )
{
	YAO_FILE_HEADER	fileHeader;
	YAOStatus 		rc; // return code

	// t@Cw肳Ă邩H
	if( inFilePath == NULL )
	{
		return kYAO_Failure;
	}

	// YAO_FILEw肳Ă邩H
	if( outFile == NULL )
	{
		return kYAO_Failure;
	}

	// YAO_FILE
	outFile->accessMode = inAccessMode;
	outFile->filePointer = NULL;
	outFile->currentExist = false; //͂߂̓JgȂ

	// ANZX[hɂăt@CJ
	if( inAccessMode == kYAO_ReadWrite )
	{
		// t@CǂݏpAoCi[hŊJ
		outFile->filePointer = fopen( inFilePath, "r+b" );
		if( outFile->filePointer == NULL )
		{
			return kYAO_Failure;
		}
	}
	else if( inAccessMode == kYAO_ReadOnly )
	{
		// t@CǂݎpAoCi[hŊJ
		outFile->filePointer = fopen( inFilePath, "rb" );
		if( outFile->filePointer == NULL )
		{
			return kYAO_Failure;
		}
	}
	else
	{
		return kYAO_Failure;
	}

	// t@Cwb_ǂݏo YAO t@CǂmF
	rc = MyReadData( outFile, &fileHeader, sizeof(YAO_FILE_HEADER) );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	if( fileHeader.signature[0] != 'Y' )
	{
		return kYAO_Failure;	//  YAO t@CłȂ
	}
	if( fileHeader.signature[1] != 'A' )
	{
		return kYAO_Failure;	//  YAO t@CłȂ
	}
	if( fileHeader.signature[2] != 'O' )
	{
		return kYAO_Failure;	//  YAO t@CłȂ
	}
	if( fileHeader.version != kYAOVersion )
	{
		return kYAO_Failure;	// قȂo[Wł
	}

	return kYAO_Success;
}


//-------------------------------------------------
// O : YAO_Close
// @\ : YAO t@C
//-------------------------------------------------
// 20050912 mod (shiina, yatou) fclosegp悤ύX
//                              YAO_FILË̗JsȂ悤ɂ
void YAO_Close( YAO_FILE * ioFile )
{	
	// YAOt@Cw肳Ă邩H
	if( ioFile == NULL )
	{
		return;
	}
	
	// t@C
	if( ioFile->filePointer != NULL )
	{
		fclose( ioFile->filePointer );
	}
}

//------------------------------------------------
// ֐ : YAO_AddData
// @\ : w^OɃf[^ǉ
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_FileIsReadOnly	... ǂݎp[h
//------------------------------------------------
// 20050912 mod (shiina, yatou) AddMemberObjAddTagObjɕ
//                              inDataBuffŌɓn悤ɕύX
//                              ǂݎp[hȂΒɏI悤ɕύX
YAOStatus YAO_AddData( YAO_FILE * ioFile, YAOTag inTag, long inDataLen, void * inDataBuff )
{
	YAOStatus rc; // return code

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}
	
	// ǂݎp[hł邩H
	if( ioFile->accessMode == kYAO_ReadOnly )
	{
		return kYAO_FileIsReadOnly;
	}

	// ̓^OGg[|Cg̃^OȂ玸s
	if( inTag == kEntryPointTag ) 
	{
		return kYAO_Failure;
	}
	
	// ̓obt@w肳Ă邩H
	if( inDataBuff == NULL )
	{
		return kYAO_Failure;
	}

	// w肵^OIuWFNg̃oɒǉ
	rc = AddMemberObj( ioFile, inTag, inDataLen, inDataBuff );
	if( rc == kYAO_TagNotFound )  // w^Õo
	{
		rc = AddTagObj( ioFile, inTag, inDataLen, inDataBuff ); // V^OIuWFNgǉ
	}
	
	return rc;
}

//------------------------------------------------
// ֐ : YAO_InsertData
// @\ : f[^Jg̑Oɑ}
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_NoCurrent		... Jg
//        kYAO_FileIsReadOnly	... ǂݎp[h
//------------------------------------------------
// 20050912 mod (shiina, yatou) Jg̑ÖʒuɃf[^}悤ɕύX
//                              inDataBuffŌɓn悤ɕύX
//                              ǂݎp[hȂΒɏI悤ɕύX
YAOStatus YAO_InsertData( YAO_FILE * ioFile, long inDataLen, void * inDataBuff )
{
	YAOStatus	rc; // return code

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}
	
	// ǂݎp[hł邩H
	if( ioFile->accessMode == kYAO_ReadOnly )
	{
		return kYAO_FileIsReadOnly;
	}

	// ̓obt@w肳Ă邩H
	if( inDataBuff == NULL )
	{
		return kYAO_Failure;
	}
	
	// Jg邩H
	if( ioFile->currentExist == false )
	{
		return kYAO_NoCurrent;
	}

	// Jg^OȂAo̐擪Ƀf[^}
	// JgoȂAJgo̒OɃf[^}
	if( IsTagObj( ioFile->currentMetaData ) == true )
	{
		rc = InsertTagObj( ioFile, inDataLen, inDataBuff );
	}
	else
	{
		rc = InsertMemberObj( ioFile, inDataLen, inDataBuff );
	}

	return rc;
}

//------------------------------------------------
// ֐ : YAO_RemoveData
// @\ : Jg̈ʒuɂf[^폜
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_NoCurrent		... Jg
//        kYAO_FileIsReadOnly	... ǂݎp[h
//------------------------------------------------
// 20050912 mod (shiina, yatou) Jg̃f[^폜悤ɕύX
//                              ǂݎp[hȂΒɏI悤ɕύX
YAOStatus YAO_RemoveData( YAO_FILE * ioFile )
{
	YAOStatus	rc; // return code
	
	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}
	
	// ǂݎp[hł邩H
	if( ioFile->accessMode == kYAO_ReadOnly )
	{
		return kYAO_FileIsReadOnly;
	}

	// Jg邩H
	if( ioFile->currentExist == false )
	{
		return kYAO_NoCurrent;
	}

	// Jg^OȂ烁o̐擪폜
	// Jg^OłȂȂAJg̃o폜
	if( IsTagObj( ioFile->currentMetaData ) == true )
	{
		rc = RemoveTagObj( ioFile );
	}
	else
	{
		rc = RemoveMemberObj( ioFile );
	}

	return rc;
}

//------------------------------------------------
// ֐ : YAO_GetData
// @\ : Jg̃f[^擾
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_NoCurrent	... Jg
//------------------------------------------------
// 20050831 mod (shiina, yatou) Jg̃f[^擾悤ɕύX
YAOStatus YAO_GetData( YAO_FILE * ioFile, long inBufferLen, void * outBuff )
{
	YAOStatus	rc; // return code

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}
	
	// o͐obt@w肳Ă邩H
	if( outBuff == NULL )
	{
		return kYAO_Failure;
	}
	
	// Jg邩H
	if( ioFile->currentExist == false )
	{
		return kYAO_NoCurrent;
	}

	// pӂꂽobt@̃TCY͏\H
	if( ioFile->currentMetaData.length > inBufferLen )
	{
		return kYAO_Failure;
	}

	// ^ꂽ^f[^̎f[^Ɉړ
	rc = MySetFilePointer( ioFile, ioFile->currentMetaData.filePointer + sizeof(YAO_METADATA) );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// f[^擾
	rc = MyReadData( ioFile, outBuff, ioFile->currentMetaData.length );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	return kYAO_Success;
}


//------------------------------------------------
// ֐ : YAO_GetDataLength
// @\ : Jg̃f[^̒擾
// Ԓl : Jg̃f[^̒Ԃ
//        G[Jg -1 Ԃ
//------------------------------------------------
// 20050831 mod (shiina, yatou) Jg̃f[^̒擾悤ɕύX
long YAO_GetDataLength( YAO_FILE * ioFile )
{
	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return -1;
	}
	
	// Jg邩H
	if( ioFile->currentExist == false )
	{
		return -1;
	}
	
	return ioFile->currentMetaData.length;
}

//------------------------------------------------
// ֐ : YAO_FirstMember
// @\ : w^O̍ŏ̃oɈړ
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_TagNotFound	... w^OȂ
//------------------------------------------------
// 20050831 mod (shiina, yatou) ֐FindFirstMembergp悤ɕύX
YAOStatus YAO_FirstMember( YAO_FILE * ioFile, YAOTag inTag )
{
	YAOStatus 		rc; // return code;
	YAO_METADATA 	metadata;

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}

	// w^O̍ŏ̃o擾AJgɐݒ
	rc = FindFirstMember( ioFile, inTag, &metadata );
	if( rc == kYAO_Success )
	{
		ioFile->currentMetaData = metadata;
		ioFile->currentExist = true;

	}
	
	return rc;
}

//------------------------------------------------
// ֐ : YAO_NextMember
// @\ : ̃oɈړ
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_MemberNotFound	... ̃oȂ
//        kYAO_NoCurrent		... Jg
//------------------------------------------------
// 20050831 mod (shiina, yatou) Jg̎̃oɈړ悤ɕύX
//                              ֐FindNextMembergp悤ɕύX
YAOStatus YAO_NextMember( YAO_FILE * ioFile )
{
	YAOStatus 		rc; // return code
	YAO_METADATA 	metadata;

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false ) 
	{
		return kYAO_Failure;
	}
	
	// Jg邩H
	if( ioFile->currentExist == false )
	{
		return kYAO_NoCurrent;
	}

	// Jg̎̃o擾AJgɐݒ
	metadata = ioFile->currentMetaData;
	rc = FindNextMember( ioFile, &metadata );
	if( rc == kYAO_Success )
	{
		ioFile->currentMetaData = metadata;
	}
	
	return rc;
}

//------------------------------------------------
// ֐ : YAO_PreviousMember
// @\ : ÕoɈړ
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_MemberNotFound	... ÕoȂ
//        kYAO_NoCurrent		... Jg
//------------------------------------------------
// 20050831 mod (shiina, yatou) Jg̑ÕoɈړ悤ɕύX
//                              ֐FindPreviousMembergp悤ɕύX
YAOStatus YAO_PreviousMember( YAO_FILE * ioFile )
{
	YAOStatus 		rc; // return code
	YAO_METADATA	metadata;

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false ) 
	{
		return kYAO_Failure;
	}
	
	// Jg邩H
	if( ioFile->currentExist == false )
	{
		return kYAO_NoCurrent;
	}

	// Jg̑Õf[^擾AJgɐݒ
	metadata = ioFile->currentMetaData;
	rc = FindPreviousMember( ioFile, &metadata );
	if( rc == kYAO_Success )
	{
		ioFile->currentMetaData = metadata;
	}

	return rc;
}

//------------------------------------------------
// ֐ : YAO_FirstTag
// @\ : ŏ̃^OIuWFNgɈړ
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_TagNotFound	... 1^O
//------------------------------------------------
// 20050831 add (shiina, yatou)
YAOStatus YAO_FirstTag( YAO_FILE * ioFile )
{
	YAOStatus 		rc; // return code
	YAO_METADATA	metaData;

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}

	// Gg[|Cg擾
	rc = FindFirstTagObj( ioFile, &metaData );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// Gg[|Cg̎̃^OIuWFNg擾
	rc = FindNextTagObj( ioFile, &metaData );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// 擾^OIuWFNgJgɐݒ
	ioFile->currentExist = true;
	ioFile->currentMetaData = metaData;

	return kYAO_Success;
}

//------------------------------------------------
// ֐ : YAO_NextTag
// @\ : ̃^OIuWFNgɈړ
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_NoCurrent	... Jg
//        kYAO_TagNotFound	... ̃^O
//------------------------------------------------
// 20050831 add (shiina, yatou)
YAOStatus YAO_NextTag( YAO_FILE * ioFile )
{
	YAOStatus 		rc; // return code
	YAO_METADATA	metaData;
	YAOTag 			currentTag;

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}
	
	// Jg邩H
	if( ioFile->currentExist == false )
	{
		return kYAO_NoCurrent;
	}

	// ݃^O̍ŏ̃o擾
	currentTag = ioFile->currentMetaData.dataTag;
	metaData = ioFile->currentMetaData;
	if( IsTagObj( metaData ) == false ) // Jgŏ̃oȂ牽Ȃ
	{
		rc = FindFirstMember( ioFile, currentTag, &metaData );
		if( rc != kYAO_Success )
		{
			return rc;
		}
	}
	
	// ̃^OIuWFNg擾
	rc = FindNextTagObj( ioFile, &metaData );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// 擾^OIuWFNgJgɐݒ
	ioFile->currentMetaData = metaData;

	return kYAO_Success;
}

//------------------------------------------------
// ֐ : YAO_PreviousTag
// @\ : Õ^OIuWFNgɈړ
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_NoCurrent	... Jg
//        kYAO_TagNotFound	... Õ^O
//------------------------------------------------
// 20050831 add (shiina, yatou)
YAOStatus YAO_PreviousTag( YAO_FILE * ioFile )
{
	YAOStatus 		rc; // return code
	YAO_METADATA	metaData;
	YAOTag 			currentTag;

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}
	
	// Jg邩H
	if( ioFile->currentExist == false )
	{
		return kYAO_NoCurrent;
	}

	// ݃^O̍ŏ̃o擾
	currentTag = ioFile->currentMetaData.dataTag;
	metaData = ioFile->currentMetaData;
	if( IsTagObj( metaData ) == false ) // Jgŏ̃oȂ牽Ȃ
	{
		rc = FindFirstMember( ioFile, currentTag, &metaData );
		if( rc != kYAO_Success )
		{
			return rc;
		}
	}
	
	// Õ^OIuWFNg擾
	rc = FindPreviousTagObj( ioFile, &metaData );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// Õ^OGg[|Cgł邩H
	if( metaData.dataTag == kEntryPointTag )
	{
		return kYAO_TagNotFound;
	}

	// 擾^OIuWFNgJgɐݒ
	ioFile->currentMetaData = metaData;

	return kYAO_Success;
}

//------------------------------------------------
// ֐ : IsTagObj
// @\ : ^OIuWFNgǂ𔻒
// Ԓl : true		... ^OIuWFNgł
//        false		... ^OIuWFNgłȂ
//------------------------------------------------
// 20050831 mod (shiina, yatou) Gg[|Cgł邩ǂ͕̔KvȂ̂ō폜
static bool IsTagObj( YAO_METADATA inMetaData )
{
	// ŏ̃oł邩H
	if( inMetaData.previousMemberPointer == kMemberNotFound )
	{
		return true;
	}
	
	return false;
}

//------------------------------------------------
// ֐ : InitMetaData
// @\ : ^f[^
//------------------------------------------------
static void InitMetaData( YAO_METADATA * ioMetaDataPtr )
{
	ioMetaDataPtr->dataTag					= 0;				// ^O0ɏ
	ioMetaDataPtr->length					= 0;				// f[^̒0ɏ
	ioMetaDataPtr->filePointer				= 0;				// t@C̈ʒu0ɏ
	ioMetaDataPtr->previousMemberPointer	= kMemberNotFound;	// ÕoȂ
	ioMetaDataPtr->nextMemberPointer		= kMemberNotFound;	// ̃oȂ
	ioMetaDataPtr->previousTagPointer		= kTagNotFound;		// Õ^OȂ
	ioMetaDataPtr->nextTagPointer			= kTagNotFound;		// ̃^OȂ
}

//------------------------------------------------
// ֐ : ReadMetaData
// @\ : ^f[^t@Cǂݍ
// Ԓl : kYAO_Success		... 
//        kYAO_FileIO_Err	... t@Co̓G[
//------------------------------------------------
// 20050831 add (shiina, yatou) 
static YAOStatus ReadMetaData( YAO_FILE * ioFile, long inPosition, YAO_METADATA * outMetaDataPtr )
{
	YAOStatus	rc; // return code
	
	// ^ꂽʒuɓǂݏoʒuړ
	rc = MySetFilePointer( ioFile, inPosition );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// ^f[^t@Cǂݍ
	rc = MyReadData( ioFile, outMetaDataPtr, sizeof(YAO_METADATA) );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	return kYAO_Success;
}

//------------------------------------------------
// ֐ : WriteMetaData
// @\ : ^f[^t@Cɏ
// Ԓl : kYAO_Success		... 
//        kYAO_FileIO_Err	... t@Co̓G[
//------------------------------------------------
// 20050831 add (shiina, yatou)
static YAOStatus WriteMetaData( YAO_FILE * ioFile, YAO_METADATA * inMetaDataPtr )
{
	YAOStatus	rc; // return code
	
	// w肳ꂽ^f[^̃t@C̈ʒuɏ݈ʒuړ
	rc = MySetFilePointer( ioFile, inMetaDataPtr->filePointer );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// w肳ꂽ^f[^t@Cɏ
	rc = MyWriteData( ioFile, inMetaDataPtr, sizeof(YAO_METADATA) );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	return kYAO_Success;
}

//------------------------------------------------
// ֐ : FindFirstTagObj
// @\ : Gg[|Cg擾
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//------------------------------------------------
// 20050831 mod (shiina, yatou) ԂllongYAOStatusɏC
static YAOStatus FindFirstTagObj( YAO_FILE * ioFile, YAO_METADATA * outMetaDataPtr )
{
	YAOStatus rc; // return code

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}
	
	// o͐悪w肳Ă邩H
	if( outMetaDataPtr == NULL )
	{
		return kYAO_Failure;
	}

	// Gg[|Cgt@Cǂݍ
	rc = ReadMetaData( ioFile, sizeof(YAO_FILE_HEADER), outMetaDataPtr );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	return kYAO_Success;
}


//------------------------------------------------
// ֐ : FindNextTagObj
// @\ : ̃^OIuWFNg擾
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_TagNotFound	... Ȃ
//------------------------------------------------
// 20050831 mod (shiina, yatou) ԂllongYAOStatusɏC
static YAOStatus FindNextTagObj( YAO_FILE * ioFile, YAO_METADATA * ioMetaDataPtr )
{
	YAOStatus 	rc;	// return code
	long 		nextTagObjPos;

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}
	
	// ^f[^w肳Ă邩H
	if( ioMetaDataPtr == NULL )
	{
		return kYAO_Failure;
	}

	// w肳ꂽ^f[^^OIuWFNgł邩H
	if( IsTagObj( *ioMetaDataPtr ) == false )
	{
		return kYAO_Failure;
	}
	
	// w肳ꂽ^f[^̎ɂ^OIuWFNg̈ʒu擾
	nextTagObjPos = ioMetaDataPtr->nextTagPointer;
	if( nextTagObjPos == kTagNotFound )
	{
		return kYAO_TagNotFound;
	}

	// ^OIuWFNgt@Cǂݍ
	rc = ReadMetaData( ioFile, nextTagObjPos, ioMetaDataPtr );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	return kYAO_Success;
}


//------------------------------------------------
// ֐ : FindPreviousTagObj
// @\ : Õ^OIuWFNg擾
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_TagNotFound	... Ȃ
//------------------------------------------------
// 20050831 mod (shiina, yatou) ԂllongYAOStatusɏC
static YAOStatus FindPreviousTagObj( YAO_FILE * ioFile, YAO_METADATA * ioMetaDataPtr )
{
	YAOStatus 	rc; // return code
	long 		prevTagObjPos;

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}
	
	// ^f[^w肳Ă邩H
	if( ioMetaDataPtr == NULL )
	{
		return kYAO_Failure;
	}

	// w肳ꂽ^f[^^OIuWFNgł邩H
	if( IsTagObj( *ioMetaDataPtr ) == false )
	{
		return kYAO_Failure;
	}

	// w肳ꂽ^f[^̑Oɂ^OIuWFNg̈ʒu擾
	prevTagObjPos = ioMetaDataPtr->previousTagPointer;
	if( prevTagObjPos == kTagNotFound )
	{
		return kYAO_TagNotFound;
	}
	
	// ^OIuWFNgt@Cǂݍ
	rc = ReadMetaData( ioFile, prevTagObjPos, ioMetaDataPtr );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	return kYAO_Success;
}
		
//------------------------------------------------
// ֐ : FindLastTagObj
// @\ : Ō̃^OIuWFNg擾
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//------------------------------------------------
// 20050831 mod (shiina, yatou) ԂllongYAOStatusɏC
static YAOStatus FindLastTagObj( YAO_FILE * ioFile, YAO_METADATA * outMetaDataPtr )
{
	YAOStatus 		rc; // return code
	YAO_METADATA 	metaData;

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}
	
	// o͐悪w肳Ă邩H
	if( outMetaDataPtr == NULL )
	{
		return kYAO_Failure;
	}
	

	// Gg[|Cg擾
	rc = FindFirstTagObj( ioFile, &metaData );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// Ō̃^OIuWFNg
	while( metaData.nextTagPointer != kTagNotFound )
	{
		// ̃^OIuWFNg
		rc = FindNextTagObj( ioFile, &metaData );
		if( rc != kYAO_Success )
		{
			return rc;
		}
	}

	*outMetaDataPtr = metaData;
	return kYAO_Success;
}

//------------------------------------------------
// ֐ : FindFirstMember
// @\ : w^O̍ŏ̃o擾
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_TagNotFound	... w^OȂ
//------------------------------------------------
// 20050831 add (shiina, yatou)
static YAOStatus FindFirstMember( YAO_FILE * ioFile, YAOTag inTag, YAO_METADATA * outMetaDataPtr )
{
	YAOStatus		rc;	// return code
	YAO_METADATA	metaData;

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}

	// o͐悪w肳Ă邩H
	if( outMetaDataPtr == NULL )
	{
		return kYAO_Failure;
	}

	// ̓^OGg[|Cg̃^Oł΃G[
	if( inTag == kEntryPointTag )
	{
		return kYAO_Failure;
	}

	// Gg[|Cg擾
	rc = FindFirstTagObj( ioFile, &metaData );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// w^O^OIuWFNg
	while( metaData.dataTag != inTag )
	{
		// ̃^OIuWFNg
		rc = FindNextTagObj( ioFile, &metaData );
		if( rc != kYAO_Success )
		{
			return rc;
		}
	}

	// o
	*outMetaDataPtr = metaData;
	return kYAO_Success;
}

//------------------------------------------------
// ֐ : FindNextMember
// @\ : w胁^f[^̎̃^f[^擾
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_MemberNotFound	... ̃oȂ
//------------------------------------------------
// 20050831 add (shiina, yatou)
static YAOStatus FindNextMember( YAO_FILE * ioFile, YAO_METADATA * ioMetaDataPtr )
{
	YAOStatus	rc;	// return code

	// ^ꂽ^f[^̎Ƀo݂邩H
	if( ioMetaDataPtr->nextMemberPointer == kMemberNotFound )
	{
		return kYAO_MemberNotFound;
	}

	// ̃oǂݏo
	rc = ReadMetaData( ioFile, ioMetaDataPtr->nextMemberPointer, ioMetaDataPtr );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	return kYAO_Success;
}

//------------------------------------------------
// ֐ : FindPreviousMember
// @\ : w胁^f[^̑Õ^f[^擾
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_MemberNotFound	... ÕoȂ
//------------------------------------------------
// 20050831 add (shiina, yatou)
static YAOStatus FindPreviousMember( YAO_FILE * ioFile, YAO_METADATA * ioMetaDataPtr )
{
	YAOStatus	rc;	// return code

	// ^ꂽ^f[^̑OɃo݂邩H
	if( ioMetaDataPtr->previousMemberPointer == kMemberNotFound )
	{
		return kYAO_MemberNotFound;
	}

	// Õoǂݏo
	rc = ReadMetaData( ioFile, ioMetaDataPtr->previousMemberPointer, ioMetaDataPtr );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	return kYAO_Success;
}

//------------------------------------------------
// ֐ : FindLastMember
// @\ : w^O̍Ō̃o擾
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_TagNotFound		... w^OȂ
//------------------------------------------------
// 20050831 mod (shiina, yatou) ԂllongYAOStatusɏC
static YAOStatus FindLastMember( YAO_FILE * ioFile, YAOTag inTag, YAO_METADATA * outMetaDataPtr )
{
	YAOStatus		rc; // return code;
	YAO_METADATA	metaData;

	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_Failure;
	}
	
	// o͐悪w肳Ă邩H
	if( outMetaDataPtr == NULL )
	{
		return kYAO_Failure;
	}

	// w^O̐擪̃o擾
	rc = FindFirstMember( ioFile, inTag, &metaData );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// Ō̃o
	while( metaData.nextMemberPointer != kMemberNotFound )
	{
		// ̃o
		rc = FindNextMember( ioFile, &metaData );
		if( rc != kYAO_Success )
		{
			return rc;
		}
	}

	// o
	*outMetaDataPtr = metaData;
	return kYAO_Success;
}

//------------------------------------------------
// ֐ : AddTagObj
// @\ : ^OIuWFNgǉ
// Ԓl : kYAO_Success    ... 
//        kYAO_Failure    ... s
//        kYAO_FileIO_Err ... t@Co̓G[
//------------------------------------------------
// 20050831 add (shiina , yatou)
static YAOStatus AddTagObj( YAO_FILE * ioFile, YAOTag inTag, long inDataLen, void * inDataBuff )
{
	YAOStatus 		rc; // return code
	YAO_METADATA	newMetaData;
	YAO_METADATA	lastTagObj;

	// Ō̃^OIuWFNg擾
	rc = FindLastTagObj( ioFile, &lastTagObj );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// ǉ郁^f[^
	InitMetaData( &newMetaData );

	// t@C̖ɏ݈ʒuړ
	rc = MySetFilePointerToEnd( ioFile );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// Ō̃^OIuWFNg̎̈ʒut@C̖Ƃ
	lastTagObj.nextTagPointer = MyGetCurrentFilePointer( ioFile );

	// Ō̃^OIuWFNgt@Cɏ
	rc = WriteMetaData( ioFile, &lastTagObj );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// t@C̖ɏ݈ʒuړ
	rc = MySetFilePointerToEnd( ioFile );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// ǉ郁^f[^
	newMetaData.dataTag = inTag;
	newMetaData.length = inDataLen;
	newMetaData.previousTagPointer = lastTagObj.filePointer;
	newMetaData.filePointer = MyGetCurrentFilePointer( ioFile ); // t@C̖w
	
	// ǉ郁^f[^t@Cɏ
	rc = MyWriteData( ioFile, &newMetaData, sizeof(YAO_METADATA) );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// ǉf[^t@Cɏ
	rc = MyWriteData( ioFile, inDataBuff, inDataLen );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	return kYAO_Success;
}

//------------------------------------------------
// ֐ : AddMemberObj
// @\ : oǉ
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_TagNotFound	... w^Õo݂Ȃ
//------------------------------------------------
// 20050831 add (shiina , yatou)
static YAOStatus AddMemberObj( YAO_FILE * ioFile, YAOTag inTag, long inDataLen, void * inDataBuff )
{
	YAOStatus 		rc; // return code
	YAO_METADATA 	lastMember;
	YAO_METADATA 	newMetaData;
	
	// w^O̍Ō̃o擾
	rc = FindLastMember( ioFile, inTag, &lastMember );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// ǉ郁^f[^
	InitMetaData( &newMetaData );
	
	// t@C̖ɏ݈ʒuړ
	rc = MySetFilePointerToEnd( ioFile );
	if( rc != kYAO_Success )
	{	
		return rc;
	}

	// Ō̃o̎̈ʒut@C̖Ƃ
	lastMember.nextMemberPointer = MyGetCurrentFilePointer( ioFile );
	
	// ύXŌ̃^f[^t@Cɏ
	rc = WriteMetaData( ioFile, &lastMember );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// t@C̖ɏ݈ʒuړ
	rc = MySetFilePointerToEnd( ioFile );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// ǉ郁^f[^
	newMetaData.dataTag = inTag;
	newMetaData.length = inDataLen;
	newMetaData.previousMemberPointer = lastMember.filePointer;
	newMetaData.filePointer = MyGetCurrentFilePointer( ioFile ); // t@C̖w
	
	// ǉ郁^f[^t@Cɏ
	rc = MyWriteData( ioFile, &newMetaData, sizeof(YAO_METADATA) );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// ǉf[^
	rc = MyWriteData( ioFile, inDataBuff, inDataLen );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	return kYAO_Success;
}

//------------------------------------------------
// ֐ : RemoveTagObj
// @\ : ^OIuWFNg폜
// Ԓl : kYAO_Success    ... 
//        kYAO_Failure    ... s
//        kYAO_FileIO_Err ... t@Co̓G[
//------------------------------------------------
// 20050831 mod (shiina, yatou) Jg̃^OIuWFNg폜悤ɕύX
static YAOStatus RemoveTagObj( YAO_FILE * ioFile )
{
	YAOStatus		rc; // return code
	long			previousTagPos;
	long			nextTagPos;
	long			nextMemberPos;
	
	// Jg̑O^OƎ^ÖʒuAJg̎öʒu擾
	previousTagPos = ioFile->currentMetaData.previousTagPointer;
	nextTagPos = ioFile->currentMetaData.nextTagPointer;
	nextMemberPos = ioFile->currentMetaData.nextMemberPointer;

	// ^Õo^OIuWFNgȊOɖH
	if( nextMemberPos == kMemberNotFound )
	{
		// Jg̑Oɂ^OIuWFNgÃ^Oւ̃|C^
		rc = UpdatePreviousTag( ioFile, nextTagPos );
		if( rc != kYAO_Success )
		{
			return rc;
		}
		
		if( nextTagPos != kTagNotFound ) // ̃^OΉȂ
		{
			// Jg̎ɂ^OIuWFNgAÕ^Oւ̃|C^
			rc = UpdateNextTag( ioFile, previousTagPos );
			if( rc != kYAO_Success )
			{
				return rc;
			}
		}
	}
	// ^OIuWFNgȊOɂoꍇ
	else
	{
		// Jg̑Oɂ^OIuWFNgÃ^Oւ̃|C^
		rc = UpdatePreviousTag( ioFile, nextMemberPos ); // ̃o
		if( rc != kYAO_Success )
		{
			return rc;
		}
		
		if( nextTagPos != kTagNotFound ) // ̃^OΉȂ
		{
			// Jg̎ɂ^OIuWFNgAÕ^Oւ̃|C^
			rc = UpdateNextTag( ioFile, nextMemberPos ); // ̃o
			if( rc != kYAO_Success )
			{
				return rc;
			}
		}
		
		// Jg̎̃oAO^OƎ^Oւ̃|C^
		rc = UpdateNextMember( ioFile, previousTagPos, nextTagPos );
		if( rc != kYAO_Success )
		{
			return rc;
		}
		
	}
	
	// Jg͍폜ꂽ̂ő݂Ȃ
	ioFile->currentExist = false;
	
	return kYAO_Success;
}

//------------------------------------------------
// ֐ : RemoveMemberObj
// @\ : o폜
// Ԓl : kYAO_Success    ... 
//        kYAO_Failure    ... s
//        kYAO_FileIO_Err ... t@Co̓G[
//------------------------------------------------
// 20050831 mod (shiina, yatou) Jg̃o폜悤ɕύX
static YAOStatus RemoveMemberObj( YAO_FILE * ioFile )
{
	YAOStatus		rc;	// return code
	YAO_METADATA	previousMemberObj;
	YAO_METADATA	nextMemberObj;
	long			nextMemberObjPos;
	long			prevMemberObjPos;

	// Jg̑Õo擾
	previousMemberObj = ioFile->currentMetaData;
	rc = FindPreviousMember( ioFile, &previousMemberObj );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// Õooւ̃|C^AJg̎oɐݒ
	nextMemberObjPos = ioFile->currentMetaData.nextMemberPointer;
	previousMemberObj.nextMemberPointer = nextMemberObjPos;

	// Õot@Cɏ
	rc = WriteMetaData( ioFile, &previousMemberObj );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// Jg̎̃o擾
	nextMemberObj = ioFile->currentMetaData;
	rc = FindNextMember( ioFile, &nextMemberObj );
	if( rc == kYAO_Success ) // ̃oΉȂ
	{
		// ̃oOoւ̃|C^AJg̑Ooɐݒ
		prevMemberObjPos = ioFile->currentMetaData.previousMemberPointer;
		nextMemberObj.previousMemberPointer = prevMemberObjPos;

		// ̃ot@Cɏ
		rc = WriteMetaData( ioFile, &nextMemberObj );
		if( rc != kYAO_Success )
		{
			return rc;
		}
	}

	// Jg͍폜ꂽ̂ő݂Ȃ
	ioFile->currentExist = false;

	return kYAO_Success;
}

//------------------------------------------------
// ֐ : InsertTagObj
// @\ : ^OIuWFNg}
// Ԓl : kYAO_Success    ... 
//        kYAO_Failure    ... s
//        kYAO_FileIO_Err ... t@Co̓G[
//------------------------------------------------
// 20050831 mod (shiina, yatou) Jg̈ʒuɃf[^}悤ɕύX
static YAOStatus InsertTagObj( YAO_FILE * ioFile, long inDataLen, void * inDataBuff )
{
	YAOStatus		rc;	// return code
	
	YAO_METADATA	newMetaData;
	YAO_METADATA	prevTagMetaData;
	YAO_METADATA	nextTagMetaData;
	
	// t@C̖ɏ݈ʒuړ
	rc = MySetFilePointerToEnd( ioFile );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// V}郁^f[^쐬
	InitMetaData( &newMetaData );
	newMetaData.dataTag = ioFile->currentMetaData.dataTag;			// JgƓ^Ow
	newMetaData.filePointer = MyGetCurrentFilePointer( ioFile );	// t@C̖w
	newMetaData.length = inDataLen;
	
	// Jg̑Õ^OIuWFNg擾
	prevTagMetaData = ioFile->currentMetaData;
	rc = FindPreviousTagObj( ioFile, &prevTagMetaData );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// Õ^OIuWFNgɁAV}^OIuWFNgA
	prevTagMetaData.nextTagPointer = newMetaData.filePointer;
	newMetaData.previousTagPointer = prevTagMetaData.filePointer;

	// Õ^OIuWFNgt@Cɏ
	rc = WriteMetaData( ioFile, &prevTagMetaData );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// ̃^OIuWFNg擾
	nextTagMetaData = ioFile->currentMetaData;
	rc = FindNextTagObj( ioFile, &nextTagMetaData );
	if( rc == kYAO_Success ) // ̃^OȂ牽Ȃ
	{
		// ̃^OIuWFNgɁAV}^OIuWFNgA
		nextTagMetaData.previousTagPointer = newMetaData.filePointer;
		newMetaData.nextTagPointer = nextTagMetaData.filePointer;

		// ̃^OIuWFNgt@Cɏ
		rc = WriteMetaData( ioFile, &nextTagMetaData );
		if( rc != kYAO_Success )
		{
			return rc;
		}
	}
	
	// Jg̑OɁAV^OIuWFNg}
	ioFile->currentMetaData.previousTagPointer = kTagNotFound;
	ioFile->currentMetaData.nextTagPointer = kTagNotFound;
	ioFile->currentMetaData.previousMemberPointer = newMetaData.filePointer;
	newMetaData.nextMemberPointer = ioFile->currentMetaData.filePointer;
	
	// XVJgt@Cɏ
	rc = WriteMetaData( ioFile, &(ioFile->currentMetaData) );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// V^f[^t@Cɏ
	rc = WriteMetaData( ioFile, &newMetaData );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// V}f[^
	rc = MyWriteData( ioFile, inDataBuff, inDataLen );
	if( rc != kYAO_Success )
	{
		return kYAO_FileIO_Err;
	}
	
	return kYAO_Success;
}


//------------------------------------------------
// ֐ : InsertMemberObj
// @\ : o}
// Ԓl : kYAO_Success    ... 
//        kYAO_Failure    ... s
//        kYAO_FileIO_Err ... t@Co̓G[
//------------------------------------------------
// 20050831 mod (shiina, yatou) Jg̈ʒuɃf[^}悤ɕύX
static YAOStatus InsertMemberObj( YAO_FILE * ioFile, long inDataLen, void * inDataBuff )
{
	YAOStatus		rc;	// return code
	YAO_METADATA	newMetaData;
	YAO_METADATA	prevMember;
	
	// t@C̖ɏ݈ʒuړ
	rc = MySetFilePointerToEnd( ioFile );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// V}郁^f[^쐬
	InitMetaData( &newMetaData );
	newMetaData.dataTag = ioFile->currentMetaData.dataTag;
	newMetaData.filePointer = MyGetCurrentFilePointer( ioFile ); // t@C̖w
	newMetaData.length = inDataLen;
	
	// Jg̑Õo擾
	prevMember = ioFile->currentMetaData;
	rc = FindPreviousMember( ioFile, &prevMember );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// ÕoɁAV}郁oA
	prevMember.nextMemberPointer = newMetaData.filePointer;
	newMetaData.previousMemberPointer = prevMember.filePointer;

	// Õot@Cɏ
	rc = WriteMetaData( ioFile, &prevMember );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// Jg̑OɐVo}
	ioFile->currentMetaData.previousMemberPointer = newMetaData.filePointer;
	newMetaData.nextMemberPointer = ioFile->currentMetaData.filePointer;

	// XVJgt@Cɏ
	rc = WriteMetaData( ioFile, &(ioFile->currentMetaData) );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// V^f[^t@Cɏ
	rc = WriteMetaData( ioFile, &newMetaData );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	// V}f[^
	rc = MyWriteData( ioFile, inDataBuff, inDataLen );
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	return kYAO_Success;
}

//------------------------------------------------
// ֐ : UpdateNextTag
// @\ : Jg̎ɗ^OIuWFNgO^Oւ̃|C^ύX
// Ԓl : kYAO_Success    ... 
//        kYAO_Failure    ... s
//        kYAO_FileIO_Err ... t@Co̓G[
//------------------------------------------------
// 20050901 add (shiina, yatou) RemoveTagObjł̂ݎg
static YAOStatus UpdateNextTag( YAO_FILE * ioFile, long inPreviousTagPos )
{
	YAOStatus		rc; // return code
	YAO_METADATA	nextTagObj;
	
	// Jg̎̃^OIuWFNg擾
	nextTagObj = ioFile->currentMetaData;
	rc = FindNextTagObj( ioFile, &nextTagObj );
	if( rc == kYAO_TagNotFound ) // ꍇ͎s
	{
		return kYAO_Failure;
	}
	if( rc != kYAO_Success ) // ̃^O邪A擾ɎsH
	{
		return rc;
	}
	
	// ̃^OAÕ^Oւ̃|C^
	nextTagObj.previousTagPointer = inPreviousTagPos;
	
	// XV^OIuWFNgt@Cɏ
	rc = WriteMetaData( ioFile, &nextTagObj );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	return rc;
}

//------------------------------------------------
// ֐ : UpdatePreviousTag
// @\ : Jg̑Oɗ^OIuWFNg^Oւ̃|C^ύX
// Ԓl : kYAO_Success    ... 
//        kYAO_Failure    ... s
//        kYAO_FileIO_Err ... t@Co̓G[
//------------------------------------------------
// 20050901 add (shiina, yatou) RemoveTagObjł̂ݎg
static YAOStatus UpdatePreviousTag( YAO_FILE * ioFile, long inNextTagPos )
{
	YAOStatus		rc; // return code
	YAO_METADATA	previousTagObj;
	
	// Jg̑Õ^OIuWFNg擾
	previousTagObj = ioFile->currentMetaData;
	rc = FindPreviousTagObj( ioFile, &previousTagObj );
	// ꍇ͎s
	if( rc == kYAO_TagNotFound )
	{
		return kYAO_Failure;
	}
	// Õ^O邪A擾ɎsH
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// Õ^OÃ^Oւ̃|C^
	previousTagObj.nextTagPointer = inNextTagPos;
	
	// XV^OIuWFNgt@Cɏ
	rc = WriteMetaData( ioFile, &previousTagObj );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	return rc;
}

//------------------------------------------------
// ֐ : UpdateNextMember
// @\ : Jg̎ɗ郁oAO^Oю^Oւ̃|C^ύX
// Ԓl : kYAO_Success    ... 
//        kYAO_Failure    ... s
//        kYAO_FileIO_Err ... t@Co̓G[
//------------------------------------------------
// 20050901 add (shiina, yatou) RemoveTagObjł̂ݎg
static YAOStatus UpdateNextMember( YAO_FILE * ioFile, long inPreviousTagPos, long inNextTagPos )
{
	YAOStatus		rc; // return code
	YAO_METADATA	nextMember;
	
	// Jg̎̃o擾
	nextMember = ioFile->currentMetaData;
	rc = FindNextMember( ioFile, &nextMember );
	// ꍇ͎s
	if( rc == kYAO_MemberNotFound )
	{
		return kYAO_Failure;
	}
	// ̃o邪A擾ɎsH
	if( rc != kYAO_Success )
	{
		return rc;
	}
	
	// ̃o擪oɂ
	nextMember.previousMemberPointer = kMemberNotFound;
	// Jg̎ɂ郁óAO^OƎ^Öʒuݒ
	nextMember.previousTagPointer = inPreviousTagPos;
	nextMember.nextTagPointer = inNextTagPos;
	
	// Jg̎̃ot@Cɏ
	rc = WriteMetaData( ioFile, &nextMember );
	if( rc != kYAO_Success )
	{
		return rc;
	}

	return rc;
}



//------------------------------------------------
// ֐ : MyIsFileExists
// @\ : wt@C݂邩ׂ
// Ԓl : true	... ݂
//        false	... ݂Ȃ   
//------------------------------------------------
// 20050831 add (shiina, yatou)  t@C݂̑fopenŒׂ邵Ȃ
static bool MyIsFileExists( const char * inFilePath )
{
	FILE * fp;
	
	// t@Cǂݍ݃[hŎɊJ
	fp = fopen( inFilePath, "r" );
	if( fp != NULL )
	{
		// t@C݂ΕĂtrueԂ
		fclose( fp );
		return true;
	}
	
	// t@C݂Ȃ
	return false;
}

//------------------------------------------------
// ֐ : MySetFilePointer
// @\ : t@C|C^wʒuɈړ
// Ԓl : kYAO_Success		... 
//        kYAO_FileIO_Err	... t@Co̓G[
//------------------------------------------------
// 20050831 mod (shiina, yatou) Windowsˑ
static YAOStatus MySetFilePointer( YAO_FILE * ioFile, long inPosition )
{
	int seekResult; // fseek̖߂l (0ȊOȂ玸s)
	
	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_FileIO_Err;
	}

	// t@C|C^ړ
	seekResult = fseek( ioFile->filePointer, inPosition, SEEK_SET );
	if( seekResult != 0 )
	{
		return kYAO_FileIO_Err;
	}
	
	return kYAO_Success;
}

//------------------------------------------------
// ֐ : MySetFilePointerToEnd
// @\ : t@C|C^t@C̍ŌɈړ
// Ԓl : kYAO_Success		... 
//        kYAO_FileIO_Err	... t@Co̓G[
//------------------------------------------------
// 20050831 mod (shiina, yatou) Windowsˑ
static YAOStatus MySetFilePointerToEnd( YAO_FILE * ioFile )
{
	int seekResult; // fseek̖߂l (0ȊOȂ玸s)
	
	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return kYAO_FileIO_Err;
	}

	// t@C|C^̈ʒut@C̖Ɉړ
	seekResult = fseek( ioFile->filePointer, 0, SEEK_END );
	if( seekResult != 0 )
	{
		return kYAO_FileIO_Err;
	}
	
	return kYAO_Success;
}


//------------------------------------------------
// ֐ : MyGetCurrentFilePointer
// @\ : t@C|C^݈̌ʒu擾
// Ԓl : t@C|C^́At@C擪̃ItZbgʒu
//        s -1 Ԃ
//------------------------------------------------
// 20050831 mod (shiina, yatou) Windowsˑ
static long MyGetCurrentFilePointer( YAO_FILE * ioFile )
{
	long position;
	
	// LYAOt@CH
	if( MyIsValidYAO_FILE( ioFile ) == false )
	{
		return -1;
	}

	position = ftell( ioFile->filePointer );
	return position;
}

//------------------------------------------------
// ֐ : MyReadData
// @\ : t@Cf[^woCgǂݏo
// Ԓl : kYAO_Success		... 
//        kYAO_FileIO_Err	... t@Co̓G[
//------------------------------------------------
// 20050831 mod (shiina, yatou) Windowsˑ
static YAOStatus MyReadData( YAO_FILE * inFile, void * outBuff, long inBufLen )
{
	long readActual;

	readActual = (long)fread( outBuff, 1, inBufLen, inFile->filePointer );
	
	// w肵ǂݍ߂ȂΎs
	if( readActual < inBufLen )
	{
		return kYAO_FileIO_Err;
	}
	
	return kYAO_Success;
}

//------------------------------------------------
// ֐ : MyWriteData
// @\ : t@CɃf[^woCg
// Ԓl : kYAO_Success		... 
//        kYAO_FileIO_Err	... t@Co̓G[
//------------------------------------------------
// 20050831 mod (shiina, yatou) Windowsˑ
static YAOStatus MyWriteData( YAO_FILE * inFile, const void * inBuff, long inBufLen )
{
	long wroteActual;

	wroteActual = (long)fwrite( inBuff, 1, inBufLen, inFile->filePointer );
	
	// w肵߂ȂΎs
	if( wroteActual < inBufLen )
	{
		return kYAO_FileIO_Err;
	}
	
	return kYAO_Success;
}

//------------------------------------------------
// ֐ : MyIsValidYAO_FILE
// @\ : YAOt@CLǂmF
// Ԓl : true		... L
//        false		... LłȂ
//------------------------------------------------
// 20050831 add (shiina, yatou) 
static bool MyIsValidYAO_FILE( YAO_FILE * ioFile )
{
	// YAOt@Cw肳ĂȂȂLłȂ
	if( ioFile == NULL )
	{
		return false;
	}
	
	// t@CJĂȂȂLłȂ
	if( ioFile->filePointer == NULL )
	{
		return false;
	}

	return true;
}

